'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var fncs = {
  cancel: function cancel(el, model) {
    $(el)[model.isNew() || !model.collection ? 'hide' : 'show']().prop(this.disabled, false);
  },
  publish: function publish(el, model) {
    $(el)[!model.isNew() && !model.get('datePublished') ? 'show' : 'hide']().prop('disabled', model.isDirty());
  },
  unpublish: function unpublish(el, model) {
    $(el)[!model.isNew() && model.get('datePublished') ? 'show' : 'hide']().prop('disabled', model.isDirty());
  },
  delete: function _delete(el, model) {
    el.disabled = model.isNew() || model.isDirty();
  },
  create: function create(el, model) {
    $(el)[model.isNew() ? 'show' : 'hide']().prop('disabled', !model.isDirty());
  },
  save: function save(el, model) {
    $(el)[!model.isNew() ? 'show' : 'hide']().prop('disabled', !model.isDirty());
  },
  reset: function reset(el, model) {
    $(el).prop('disabled', !model.isDirty());
  }
};

exports.default = {
  setActiveButton: function setActiveButton() {
    var _view = this;

    _view.$('.controls button').each(function () {
      var command = $(this).data('command');

      if (fncs[command]) {
        fncs[command](this, _view.model);
      }
    });
  }
};
module.exports = exports['default'];