'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = unflatten;
// return an unflattened copy of attrs
// merging dot-delimited attributes with nested attributes in this.attributes
function unflatten(attrs, mergeAttrs) {
  var result = {};
  var attributes = mergeAttrs || {};

  // eslint-disable-next-line
  for (var attr in attrs) {
    var val = attrs[attr];
    var path = attr.split('.');

    if (path.length > 1) {
      attr = path.pop();

      var obj = _.reduce(path, makeNested, result);

      if (obj[attr] !== val) {
        obj[attr] = val;
      }
    } else {
      result[attr] = val;
    }
  }

  function makeNested(obj, key, level) {
    var attrs = (level || _.has(obj, key) ? obj : attributes)[key];

    obj = obj[key] = {};

    _.some(attrs, function (val, key) {
      // check that we are not iterating an array-like object
      if (typeof key === 'number') return true;

      obj[key] = val;
    });

    return obj;
  }

  return result;
}
module.exports = exports['default'];