'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _formStyling = require('./form-styling');

var _formStyling2 = _interopRequireDefault(_formStyling);

var _domGetters = require('../util/dom-getters');

var _domSetters = require('../util/dom-setters');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = _formStyling2.default.extend({
  events: {
    submit: 'submit'
  },

  submit: function submit(e) {
    e.preventDefault();

    var query = {};

    _.each(this.$el.prop('elements'), function (elem) {
      // TODO this will currently loop through all checkboxes
      // and radio buttons in a group.
      if (!elem.name) return;

      var value = (0, _domGetters.value)(elem);

      if (value) {
        query[encodeURIComponent(elem.name)] = encodeURIComponent(value).replace('%20', '+');
      }
    });

    var url = this.url || '/' + Backbone.history.fragment.split('?')[0];

    if (!_.isEmpty(query)) url += '?' + $.param(query);

    Backbone.history.navigate(url, { trigger: true });
  },
  initialize: function initialize(options) {
    this.listenTo(this.state, 'change:query', this.attach);

    this.url = options.url;
  },
  attach: function attach() {
    var query = this.state.get('query') || {};

    _.each(this.$el.prop('elements'), function (elem) {
      (0, _domSetters.value)(elem, query[elem.name] || '');
      $(elem).trigger('change');
    });
  }
});
module.exports = exports['default'];